Package: idendr0
Type: Package
Title: Interactive Dendrograms
Version: 1.5.4
Date: 2026-03-16
Author: Tomas Sieger [aut, cre]
Authors@R: person(given = "Tomas",
    family = "Sieger",
    role = c("aut", "cre"),
    email = "tomas.sieger@seznam.cz")
Depends:
Imports: tcltk, tkrplot, grDevices, graphics, stats
Suggests: DendSer, cluster, RColorBrewer, datasets, loon, MASS,
        flowStats, hyperSpec
URL: https://github.com/tsieger/idendr0
Maintainer: Tomas Sieger <tomas.sieger@seznam.cz>
BugReports: https://github.com/tsieger/idendr0/issues
Description: Interactive dendrogram that enables the user to select and
    color clusters, to zoom and pan the dendrogram, and to visualize
    the clustered data not only in a built-in heat map, but also in
    'GGobi' interactive plots and user-supplied plots. 
    This is a backport of Qt-based 'idendro' 
    (<https://github.com/tsieger/idendro>) to base R graphics and 
    Tcl/Tk GUI.
License: GPL-2
LazyLoad: yes
LazyData: true
NeedsCompilation: no
Packaged: 2026-03-16 22:21:26 UTC; sieger
Repository: CRAN
Date/Publication: 2026-03-17 08:10:02 UTC
Built: R 4.6.0; ; 2026-04-26 20:04:57 UTC; unix

# idendr0

'idendr0' is an interactive dendrogram that enables the user to select 
and color clusters, to zoom and pan the dendrogram, and to visualize 
the clustered data not only in a built-in heat map, but also in 
[GGobi](http://ggobi.org/) interactive plots and user-supplied plots. 

idendr0 is a backport of [idendro](https://github.com/tsieger/idendro)
to base R graphics and Tcl/Tk GUI.

#### Documentation

[A paper](http://dx.doi.org/10.18637/jss.v076.i10) in the 
[Journal of Statistical Software](https://www.jstatsoft.org/)
and [idendro vignette](/inst/doc/idendro.pdf).

## To install:

* the latest released version: `install.packages("idendr0")`
* the latest development version: `devtools::install_github("tsieger/idendr0")`

##### A simple example:

    library(idendr0)
    hc <- hclust(dist(iris[, 1:4]))
    idendro(hc, iris)

![Example](/man/figures/idendr0_1.png?raw=true "Simple example.")

##### Integration with other plots

Please see `demo(idendroWithScatterAndParcoord)`, 
which, in addition to the dendrogram, creates two feature space plots:

![Example](/man/figures/idendr0_2.png?raw=true "Integration with other plots.")

For more demos, please run `demo(package="idendr0")`'.

Find out more at https://github.com/tsieger/idendr0.

## idendro + ggobi integration demo.
##

library(idendr0) # idendro

data(iris)

# perform hierarchical clustering analysis
hc <- hclust(dist(iris[, 1:4]))

# visualize clusters and heat map
idendro(hc, iris, hscale = 1, vscale = 1.2,
    ggobi = TRUE, ggobiGlyphType = 4, ggobiGlyphSize = 2)

## Visualization of flow cytometry data in dendrogram and heat
## map, with two scatter plots integrated.
##

library(flowStats) # ITN
library(RColorBrewer) # brewer.pal
library(idendr0) # idendro

data(ITN)

# get data matrix
x <- exprs(ITN$sample03[, 1:7])
# preprocess the data
x[, 3:7] <- log10(x[, 3:7])
x <- scale(x)

# perform HCA
cat('computing HCA (this takes a while)\n')
hx <- hclust(dist(x), method = 'average')

# setup scatter plots of selected data projections
dev.new()
par(ask = FALSE)
sp1 <- dev.cur()
dev.new()
par(ask = FALSE)
sp2 <- dev.cur()

clusterColors <- brewer.pal(12, "Paired")

colorizeCallback <- function(clr) {
    d<-dev.cur()
    dev.set(sp1)
    plot(x[,"CD3"], x[,"HLADr"], pch = 19, col = c('black',clusterColors)[clr + 1])
    dev.set(sp2)
    plot(x[,"CD8"], x[,"CD4"], pch = 19, col = c('black',clusterColors)[clr + 1])
    dev.set(d)
}

# produce the scatter plots by invoking the callback function with no specific colors
colorizeCallback(0)

# plot dendrogram + heat map
cat('plotting dendrogram\n')
idendro(hx, x,
    heatmapColors = colorRampPalette(c("purple4", "blue3", "blue3", "grey",
        "grey", "orangered", "orangered", "red"))(15),
    clusterColors = clusterColors,
    colorizeCallback = colorizeCallback)

## Demo of dendrogram + heat map integrated with GGobi scatter plot
## matrix using "big data" (5000 observations).
##

library(idendr0) # hca5000, idendro

# load "big data"
data(hca5000)

# visualize clusters
idendro(hca5000$hx, hca5000$x, ggobi = TRUE)

## idendro + scatter plot integration demo.
##

library(idendr0) # idendro

data(iris)

# perform hierarchical clustering analysis
hc <- hclust(dist(iris[, 1:4]))

opar <- par(ask = FALSE)
# produce a scatter plot
plot(iris$Sepal.Length, iris$Sepal.Width, pch=19)

colorizeCallback <- function(clr) {
    # color the scatter plot according to the current clusters
    clusterColors <- c('black','red', 'green', 'blue', 'yellow', 'magenta',
        'cyan', 'darkred', 'darkgreen', 'purple', 'darkcyan')
    opar <- par(ask = FALSE)
    plot(iris$Sepal.Length, iris$Sepal.Width,
        col = clusterColors[clr + 1], pch = 19)
    par(opar)
}

# visualize clusters and heat map
idendro(hc, iris, colorizeCallback = colorizeCallback)

par(opar)

## Demo showing how `DendSer::dser' can be used to optimize dendrogram
## ordering in `idendro'.
## (This demo is based on the example provided for `dser'.)
##

library(DendSer) # dser
library(idendr0) # idendro

# hierarchical cluster analysis over iris data
d <- dist(scale(iris[, -5]))
h <- hclust(d)

# compute the first principal component (PC1) of iris data
PC1 <- prcomp(iris[,-5], scale = TRUE)$x[, 1]
# for visualization purposes, and PC1 to the data
iris.with.pc1 <- cbind(iris, PC1)

# draw dendrogram with heat map
cat('original dendrogram\n')
idendro(h, iris.with.pc1)
# note the order of the observations (rows in heat map) does not
# reflect the Species well (and PC1 either)

# Let's reorder the observations by the PC1 using 'DendSer::dser'
h$order <- dser(h, PC1, cost = costLS)
cat('reordered dendrogram\n')
idendro(h, iris.with.pc1)
# note the order of observations is much more natural when sorted

## idendro + loon integration demo.
##

library(idendr0) # idendro
library(loon) # l_pairs, l_plot

# cluster colors
clusterColors <- c('red','green','blue','yellow','magenta','cyan','darkred','darkgreen','purple','darkcyan')
# make the loon color equal to the one used by idendro
l_setColorList(clusterColors)

data(iris)

# perform hierarchical clustering analysis
hc <- hclust(dist(iris[, 1:4]))

# create a single scatter plot and a scatter plot matrix with common linking
# group (in order to propagate the interaction in between the plots)
p <- l_plot(iris[,c(1,3)], linkingGroup='myLG')
p2 <- l_pairs(iris, linkingGroup='myLG')

# callback to colorize observations
colCb<-function(cols) {
    # color of value 0 (unselected cluster) gets rendered as light gray
    p['color']<-c('gray90',clusterColors)[1+cols]
}
# callback to fetch the currently selected observations
fetchSelCb<-function() {
    p['selected']
}

# visualize clusters and heat map
idendro(hc, iris, hscale = 1, vscale = 1.2,
    colorizeCallback = colCb, fetchSelectedCallback = fetchSelCb, clusterColors = clusterColors)

## idendro + scatter plot + parallel coordinate plot integration demo.
##

library(idendr0) # idendro

data(iris)

# perform hierarchical clustering analysis
hc <- hclust(dist(iris[, 1:4]))

# setup a scatter plot
dev.new()
par(ask = FALSE)
scatterDevId <- dev.cur()

# setup a parallel coordinate plot
if (require(MASS)) {
    dev.new()
    par(ask = FALSE)
    parcoordDevId <- dev.cur()
    iris.numeric <- iris
    iris.numeric$Species <- as.numeric(iris.numeric$Species)
} else {
    parcoordDevId <- NA
}

colorizeCallback <- function(clr) {
    clusterColors <- c('black', 'red', 'green', 'blue', 'yellow', 'magenta',
        'cyan', 'darkred', 'darkgreen', 'purple', 'darkcyan')

    # color the scatter plot
    dev.set(scatterDevId)
    opar <- par(ask = FALSE, mai = par('mai') * c(1, 1, .5, 1))
    with(iris, plot(Sepal.Length, Sepal.Width, col = clusterColors[clr + 1], ty = 'p', pch=19))
    par(opar)

    # color the parallel coordinate plot
    if (!is.na(parcoordDevId)) {
        dev.set(parcoordDevId)
        opar <- par(ask = FALSE, mai = par('mai') * c(.5, 1, 1, 1))
        parcoord(iris.numeric, col = clusterColors[clr + 1])
        par(opar)
    }
}

# produce the scatter plot and the parallel coordinate plot
# by invoking the callback function with no specific colors
colorizeCallback(0)
# visualize clusters and heat map
idendro(hc, iris, colorizeCallback = colorizeCallback, hscale = 1.3, vscale = 1.3)

## Simple visualization of the result of `cluster::agnes' and
## `cluster::diana'.
##

library(idendr0) # idendro
library(cluster) # agnes, diana

data(iris)

dx <- dist(iris[, 1:4])

# perform hierarchical clustering using `agnes'
hx.agnes <- agnes(dx)
# visualize clusters
cat('"agnes" clustering\n')
idendro(hx.agnes, iris)

# perform hierarchical clustering using `diana'
hx.diana <- diana(dx)
# visualize clusters
cat('"diana" clustering\n')
idendro(hx.diana, iris)

## Demo on persisting the clusters selected in the dendrogram.
##

library(idendr0) # idendro

data(iris)

# perform hierarchical clustering analysis
hc <- hclust(dist(iris[, 1:4]))

# visualize clusters and heat map
clusters <- idendro(hc, iris)
# select some clusters, and quit idendro

# on next invokation, the clusters should be re-selected
idendro(hc, iris, clusters=clusters)

## Dendrogram + heat map demo.
##

library(idendr0) # idendro
data(iris)

# perform hierarchical clustering analysis
hc <- hclust(dist(iris[, 1:4]))

# visualize clusters and heat map
idendro(hc, iris)

## Visualization of spectroscopy data in dendrogram and heat map with
## a scatter plot and parallel coordinate plot integrated.
##

library(hyperSpec) # chondro data
library(MASS) # parcoord
library(idendr0) # idendro

# preprocess chondro data
cat('preprocessing the chondro data (it takes a while)\n')
chondro <- spc.loess(chondro, newx = seq (602, 1800, by = 4))
chondro <- chondro - spc.fit.poly.below(chondro)
chondro <- sweep(chondro, 1, rowMeans(chondro), "/")
overall.composition <- quantile(chondro, 0.05)
chondro <- sweep(chondro, 2, overall.composition, "-")

# HCA
dst <- dist(chondro)
dndr <- hclust(dst, method = "ward")

# data frame construction
df.chondro <- as.wide.df(chondro)
colnames(df.chondro)[-(1:3)] <- paste("wl", colnames(df.chondro)[-(1:3)], sep = ".")
names <- as.character(wl(chondro))
names[wl(chondro) %% 50 != 0] <- ""

# setup a scatter plot
dev.new()
par(ask = FALSE)
p1 <- dev.cur()

# setup a parallel coordinate plot
dev.new()
par(ask = FALSE)
p2 <- dev.cur()

colorizeCallback <- function(clr) {
    clusterColors <- c('black', 'red', 'green', 'blue', 'yellow', 'magenta',
        'cyan', 'darkred', 'darkgreen', 'purple', 'darkcyan')

    # color the scatter plot
    dev.set(p1)
    with(df.chondro, plot(x, y, pch = 19, col = clusterColors[clr + 1]))

    dev.set(p2)
    parcoord(df.chondro[, !colnames(df.chondro) %in% 'clusters'], col = clusterColors[clr + 1])
}

# produce the two plots by invoking the callback function with no specific colors
colorizeCallback(0)

# dendrogram
idendro(dndr, df.chondro, heatmapRelSize = 0.75, heatmapColors = alois.palette(25),
    colorizeCallback = colorizeCallback)

## Demo on clustering both rows and columns of a data set.
##

library(idendr0) # idendro

data(iris)

# Find similar variables (i.e. features measured on the Iris flowers:
# sepal/petal widths/lengths) ...
hx <- hclust(dist(t(scale(iris[, 1:4]))))
# ... and display the similarities in a dendrogram.
idendro(hx, t(iris[, 1:4]), heatmapRelSize=.7, doScaleHeatmapByRows=TRUE, mai=par('mai')*c(1,1,1,2))
# (Petal width and length being most similar.)

## Simple demo showing how to make `idendro' visualize long dimnames
## and case names in the heat map.
##

library(idendr0) # idendro

# generate data in feature space
n <- 10
x <- data.frame(very.long.dim.name1 = c(rnorm(n, -1), rnorm(n, 1)),
    long.dim.name2 = c(rnorm(n, -1), rnorm(n, 1)))
rownames(x) <- paste('my brand new observation', 1:(2*n))

# compute pairwise distances
dx <- dist(x)

# perform hierarchical clustering
hx <- hclust(dx)

# visualize clusters
# setting margins large enough to hold the long dimnames
idendro(hx, x, mai = par('mai') * c(1, 1, 1.7, 4))
